declare namespace Cypress {
  type EventOptions = {
    log?: Boolean;
    force?: Boolean;
    bubbles?: Boolean;
    cancelable?: Boolean;
    timeout?: Number;
    composed?: Boolean;
  };

  type SelectionOptions = {
    selectMultiple?: Boolean;
  };

  interface Chainable<Subject> {
    shadowClick(options?: EventOptions): Chainable<Subject>;
    shadowGet(selector: string, selectionOptions: SelectionOptions): Chainable<Subject>;
    shadowContains(content: string): Chainable<Subject>;
    shadowTrigger(eventName: string, eventOptions?: EventOptions): Chainable<Subject>;
    shadowFind(selector: string): Chainable<Subject>;
    shadowFirst(): Chainable<Subject>;
    shadowLast(): Chainable<Subject>;
  }
}
